
package de.ivu.elect.presentation.aufgabe;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.aufgabe.boundary.AufgabeKommentarBoundaryCreate;
import de.ivu.elect.business.aufgabe.entity.AufgabeKommentar;
import de.ivu.elect.business.aufgabe.entity.AufgabeKommentarMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractAufgabeKommentarCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractAufgabeKommentarCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.AUFGABE_KOMMENTAR_CREATE)
public abstract class AbstractAufgabeKommentarCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<AufgabeKommentar> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "aufgabeKommentarCreateView";

  public static final String VIEW_ID = "/aufgabe/aufgabe-kommentar-create.xhtml";

  public static final String PARENT_VIEW_ID = "/aufgabe/aufgabe-kommentar-search.xhtml";

  @Inject
  protected transient AufgabeKommentarBoundaryCreate create;

  protected AufgabeKommentar entity;

  @Inject
  protected transient AufgabeKommentarMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  AufgabeKommentar());
  }

  

  public AufgabeKommentar getEntity() {
    return entity;
  }

  protected void setEntity(AufgabeKommentar entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.AUFGABE_KOMMENTAR_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(AufgabeKommentar entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(AufgabeKommentar entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.AUFGABE_KOMMENTAR_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
